// versione Linux naca42dxf
// ----------------------------------------------------------------------
// Programmino che permette di ottenere loutput grafico nei formati:
// gnuplot
// dxf
// di profili NACA a 4 digit
// o di file dati .dat di profili
//
// ----------------------------------------------------------------------
// Piece of code that outputs:
// gnuplot
// dxf
// files format, being four digits NACA code or .dat file the input.
// 
// ----------------------------------------------------------------------
// Author: Pierpaolo Garofalo
// mail: pier@unirc.eu
//
// ----------------------------------------------------------------------
// Disclaim:
// I am not responsible for any damage this program could cause.
// You use it at your own risk!!!!
//
// ----------------------------------------------------------------------
// per abilitare lo scroll del mouse in vi
// :set mouse=a
#include <stdlib.h>
#include <math.h>
#include <stdlib.h> //exit
#include <stdio.h>    //per printf ecc
#include <fcntl.h> // gestione files
#include <string.h> //per strlen

/* per far funzionare sin etc. dare gcc -lm -lvga -lvgagl -o ..... */
/* ===================================================================*/
/* MM:spessore max camber->primo digit
   PP:percentuale corda di spessore max camber->secondo digit
   TOC:spessore profilo simmetrico->didit 3 e 4
*/
// ================== VARIABILI GLOBALI ========================
const NP_MAX = 400;

int MMr,MMe, PPr,PPe, TOCr,TOCe, NP, NPP, DESIGr, DESIGe;

float MCr, PCr, TCr;
float MCe, PCe, TCe;
float YUr[400], XLr[400], YLr[400], XUr[400];
float YUe[400], XLe[400], YLe[400], XUe[400];
float cs, cora, coes, thick, p;
float b_mezzi, freccia, sver;
float cf_min, cf_max, cf_es;
int steps[2*400-2][4], smxr, smyr, smxe, smye;
unsigned char posiz_motori=0;


//========================================================
void menu(void);
int esegui(int e);
//int round(float f);
void menu_esp_profilo(void);
void elabora(void);
void rich_output(void);
void output_gnuplot(void);
void output_dxf(void);
void menu_dati(void);
void immissione_dati(void);
void immissione_manuale(void);
void immissione_file(void);
void importazione_dxf(void);

FILE *output_file, *output_file1, *input_file;
//==============================================================================
int main()
{
  printf("\n\n\n-------------------------------------------------------\n");
  printf("\n\nProgramma per la coversione di profili aerodinamici\n");
  printf("\nNACA 4 dgt e file .dat in formato Gnuplot e DXF.\n\n");
  printf("\n\nProgram for converting aerodynamic profiles \n");
  printf("\nNACA 4 digits and .dat files Gnuplot and DXF formats.\n\n");
  printf("\n\n-------------------------------------------------------\n");
  printf("\n\nAutore/Author: Pierpaolo Garofalo\n\n");
  printf("\n\n-------------------------------------------------------\n");
  system("sleep 2");
  menu_dati();
  return(0);
}
//==============================================================================
void menu(void)
{
  int scelta;
  for(;;)
  {
    printf("\n\n\n MAIN MENU\n\n\n");
    printf(" 1)   ==> INPUT DATA PROFILE\n\n");
    printf(" 2)   ==> EXPORT PROFILE\n\n");
    //printf(" 3)   ==> TAGLIO\n\n");
    printf(" ESC) ==> EXIT\n\n");
    printf("Where do we go?");
    scelta=0;
    scelta=getchar();
      switch (scelta)
      {
	case 49:
	  menu_dati();
	  break;
	case 50:
	  menu_esp_profilo();
	  break;
	case 51:
	  //menu_taglio();
	  break;
	case 27:
	  exit(0);
      }
  }
}


//==================== IMMISSIONE DATI PROFILO UNITARIO NACA ===================
void immissione_dati(void)
{
  printf("\n\nGEOMETRIC DATA PROFILE INPUT\n\n");
  printf("\n\n\n\nFirst NACA digit (max camber percentage): ");
  scanf("%d",&MMr);
  printf("\n\nSecond NACA digit (position max camber percentage of chord / 10): ");
  scanf("%d",&PPr);
  printf("\n\nLast two digits (Thickness): ");
  scanf("%d",&TOCr);
  while ((NPP<50)|(NPP>400)| (NP<50) | (NP>400))
  {
    printf("\n\nNumber of points to generate (min 50/max 400): ");
    scanf("%d",&NPP);
    printf("\n\nNumber of calculation points (min 50/max 400): ");
    scanf("%d",&NP);
  }
/*
  printf("\n\nIMMISSIONE DATI GEOMETRICI PROFILO ESTREMITA'\n\n");
  printf("\n\n\n\nImmettere il primo digit: ");
  scanf("%d",&MMe);
  printf("\n\nImmettere il secondo digit: ");
  scanf("%d",&PPe);
  printf("\n\nImmettere gli ultimi due digit: ");
  scanf("%d",&TOCe);
*/
  elabora();
}

//==================== MENU IMMISSIONE DATI ====================================
void menu_dati(void)
{
  char scelta;
  for(;;)
  {
    scelta=3;
    //clrscr();
    printf("\n\n\n\nINPUT UNIT PROFILE DATA MENU\n\n\n\n");
    printf("1)  -> NACA 4 digits\n\n");
    printf("2)  -> Data file\n\n");
    printf("3)  -> Manual input\n\n");
    //printf("4)  -> Dati da file .dxf\n\n");
    printf("ESC -> Exit\n\n");
    printf("What now? ");
    scelta=getchar();
    switch(scelta)
    {
      case 49:
        immissione_dati();
        break;
      case 50:
        immissione_file();
        break;
      case 51:
        immissione_manuale();
        break;
      case 52:
        //importazione_dxf();
        break;
      case 27:
        menu();
    }
  }
}
//=========================== IMMISSIONE DATI DA FILE ==========================
void immissione_file(void)
{
  char nomefile[255];
  float x, y;
  int i;


// input da file per profilo radice
  system("ls *.dat | more");
  printf("\n\n\nFile name: ");
  scanf("%s",nomefile);
  //printf("%s",nomefile);
  //getch();
  input_file=fopen(nomefile,"r");
  if(input_file==NULL)
  {
    printf("\nImpossible to open the requested file!");
    system("sleep 2");
    //getch();
    return;
  }
  //conto quanti punti ci sono nel file e verifico che non eccedano il massimo
  for(i=0;;i++)
  {
    fscanf(input_file,"%f  %f",&x, &y);

    if (x==1000)
    {
      NP=i/2;
      printf("\n\nProfile with %d points", NP);
      //getch();
      break;
    }

    if (NP>400)
    {
      printf("\n\n %d > %d Too many points!",NP, 400);
      //getch();
      fclose(input_file);
      return;
    }
  }
  fclose(input_file);

  input_file=fopen(nomefile,"r");
  for (i=NP-1;i>=0;i--)
  {
    fscanf(input_file,"%f  %f",&x, &y);
    XUr[i]=x;
    YUr[i]=y;
  }
  for (i=0;i<NP;i++)
  {
    fscanf(input_file,"%f  %f",&x, &y);
    XLr[i]=x;
    YLr[i]=y;
  }
  fclose(input_file);

// input da file per profilo estremita
/*
  printf("\n\n\nImmettere nome file profilo estremita':");
  scanf("%s",nomefile);
  input_file=fopen(nomefile,"r");
  if(input_file==NULL)
  {
    printf("\nImpossibile aprire il file");
    //getch();
    return;
  }
  //conto quanti punti ci sono nel file e verifico che non eccedano il massimo
  for(i=0;;i++)
  {
    fscanf(input_file,"%f  %f",&x, &y);


    if (x==1000)
    {
      if ((i/2)!=NP)
      {
        printf("ERRORE i redice ed estremita' devono avere lo stesso numero di punti!\n\n");
        fclose(input_file);
        return;
      }

      NP=i/2;
      printf("\n\nProfilo costituito da %d punti", NP);
      //getch();
      break;
    }

    if (NP>400)
    {
      printf("\n\n %d > %d TROPPI PUNTI!",NP, 400);
      //getch();
      fclose(input_file);
      return;
    }
  }
  fclose(input_file);
  input_file=fopen(nomefile,"r");
  for (i=NP-1;i>=0;i--)
  {
    fscanf(input_file,"%f  %f",&x, &y);
    XUe[i]=x;
    YUe[i]=y;
  }
  for (i=0;i<NP;i++)
  {
    fscanf(input_file,"%f  %f",&x, &y);
    XLe[i]=x;
    YLe[i]=y;
  }
  fclose(input_file);
*/
}

//=========================== IMPORTAZIONE DA FILE DXF =========================
/*
void importazione_dxf(void)
{
//  char* nomefile;
//  char* strinp;
  char nomefile[13], strinp[20];
  float x, y;
  int i,disp,NPR;

  //clrscr();

// input da file per profilo radice

  printf("\n\n\nImmettere nome file profilo radice:");
  scanf("%s",nomefile);
  printf("%s",nomefile);
  //getch();
  input_file=fopen(nomefile,"r");
  if(input_file==NULL)
  {
    printf("\nImpossibile aprire il file");
    //getch();
    return;
  }
  //conto quanti punti ci sono nel file e verifico che non eccedano il massimo
  for(i=0;;)
  {
    fscanf(input_file,"%s",strinp);
    if (strncmp(strinp,"LINE",4)==0)
    {
      i++;
    }

    if (strncmp(strinp,"EOF",3)==0)
    {
      NP=i;
      NPR=i;
      printf("\n\nProfilo costituito da %d lati", NP);
      if (NP/2!=(float)(NP)/2)
      {
// se i lati sono dispari poi aggiungo un lato fittizio al bordi inf
        disp=1;
// i punti di ciascun semoprofilo saranno i lati + 1
      }
      else
      {
        disp=0;
      }
      NP=(NP+disp)/2+1;
      //getch();
      break;
    }
  }
  fclose(input_file);
    if (NP>400)
    {
      printf("\n\n %d > %d TROPPI PUNTI!",NP, 400);
      //getch();
      return;
    }

    if (NP==0)
    {
      printf("\n\n 0 PUNTI ERRORE!");
      //getch();
      return;
    }

  input_file=fopen(nomefile,"r");

// recupero delle coordinate dei punti il primo di ogni segmento
  for (i=0;i<NP-1;)
  {
    fscanf(input_file,"%s",strinp);
    if (strncmp(strinp,"LINE",4)==0)
    {
      fscanf(input_file,"%s",strinp);
      printf("%s \n",strinp);
      fscanf(input_file,"%s",strinp);
      printf("%s \n",strinp);
      fscanf(input_file,"%s",strinp);
      printf("%s \n",strinp);
      fscanf(input_file,"%s",strinp);
      printf("%s \n",strinp);
      fscanf(input_file,"%s",strinp);
      printf("%s \n",strinp);
      fscanf(input_file,"%f \n",&XUr[i]);
      printf("%f \n",XUr[i]);
      fscanf(input_file,"%s",strinp);
      printf("%s \n",strinp);
      fscanf(input_file,"%f\n\n",&YUr[i]);
      printf("%f \n",YUr[i]);
      fscanf(input_file,"%s",strinp);
      printf("%s \n",strinp);
      fscanf(input_file,"%f",&XUr[i+1]);
      printf("%f \n",XUr[i+1]);
      fscanf(input_file,"%s",strinp);
      printf("%s \n",strinp);
      fscanf(input_file,"%f",&YUr[i+1]);
      printf("%f \n\n",YUr[i+1]);
      i++;
    }
  }
  //getch();
for (i=NP-1;i>0+disp;)
  {
    fscanf(input_file,"%s",strinp);
    if (strncmp(strinp,"LINE",4)==0)
    {
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%f",&XLr[i]);
      printf("%f XL",XLr[i]);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%f",&YLr[i]);
      printf("%f YL",YLr[i]);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%f",&XLr[i-1]);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%f",&YLr[i-1]);
      i--;
    }
  }
  if (disp==1)
  {
    XLr[0]=XLr[1];
    YLr[0]=YLr[1];
  }
  fclose(input_file);


// input da file per profilo estremita

  printf("\n\n\nImmettere nome file profilo estremita':");
  scanf("%s",nomefile);
  printf("%s",nomefile);
  //getch();
  input_file=fopen(nomefile,"r");
  if(input_file==NULL)
  {
    printf("\nImpossibile aprire il file");
    //getch();
    return;
  }
  //conto quanti punti ci sono nel file e verifico che non eccedano il massimo
  for(i=0;;)
  {
    fscanf(input_file,"%s",strinp);

    if (strncmp(strinp,"LINE",4)==0)
    {
      i++;
    }

    if (strncmp(strinp,"EOF",3)==0)
    {
      if (i!=NPR)
      {
        printf("ERRORE i radice ed estremita' devono avere lo stesso numero di punti!\n\n");
        fclose(input_file);
        return;
      }
      NP=i;
      printf("\n\nProfilo costituito da %d lati", NP);
      if (NP/2!=(float)(NP)/2)
      {
// se i lati sono dispari poi aggiungo un lato fittizio al bordi inf
        disp=1;
// i punti di ciascun semoprofilo saranno i lati + 1
      }
      else
      {
        disp=0;
      }
      NP=(NP+disp)/2+1;
      //getch();
      break;
    }

  }

  fclose(input_file);

    if (NP>400)
    {
      printf("\n\n %d > %d TROPPI PUNTI!",NP, 400);
      //getch();
      return;
    }

    if (NP==0)
    {
      printf("\n\n 0 PUNTI ERRORE!");
      //getch();
      return;
    }

  input_file=fopen(nomefile,"r");

// recupero delle coordinate dei punti il primo di ogni segmento
  for (i=0;i<NP-1;)
  {
    fscanf(input_file,"%s",strinp);
    if (strncmp(strinp,"LINE",4)==0)
    {
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%f",&XUe[i]);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%f",&YUe[i]);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%f",&XUe[i+1]);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%f",&YUe[i+1]);

      i++;
    }

  }
  for (i=NP-1;i>0+disp;)
  {
    fscanf(input_file,"%s",strinp);
    if (strncmp(strinp,"LINE",4)==0)
    {
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%f",&XLe[i]);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%f",&YLe[i]);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%f",&XLe[i-1]);
      fscanf(input_file,"%s",strinp);
      fscanf(input_file,"%f",&YLe[i-1]);

      i--;
    }
  }
  if (disp==1)
  {
    XLe[0]=XLe[1];
    YLe[0]=YLe[1];
  }

  fclose(input_file);

}
*/
//==============================================================================
void immissione_manuale(void)
{
  //printf("\n\n\n Funzione non ancora attivata\n");
  printf("\n Function not yet implemented\n\n\n");
//getch();
}
//==============================================================================
void menu_esp_profilo(void)
{
  int scelta;

  for (;;)
  {
    scelta=48;
    //clrscr();
    printf("\n\nOUTPUT MENU\n\n\n\n");
    //printf("\n\n1)  ->  A video ");
    printf("\n\n1)  ->  GNUPLOT FILE");
    printf("\n\n2)  ->  DXF FILE");
    //printf("\n\n4)  ->  File per CNC 8051");
    //printf("\n\n5)  ->  File per CNC P/P");
    printf("\n\nESC ->  EXIT \n\n");
    printf("Your move: ");
    scelta=getchar();
    switch (scelta)
    {
      //case 49:
	//output_video();
	//break;
      case 49:
	output_gnuplot();
	break;
      case 50:
	output_dxf();
	break;
      case 52:
	//output_cnc_8051();
	break;
      case 53:
	//output_cnc_pp();
	break;
      case 27:
	return;
    }
  }
}
//====================== TAGLIO ===================================================

/*void menu_taglio()
{
  int scelta;
  for (;;)
  {
    scelta =3;
    //clrscr();
    printf("\n\n\n\nMENU TAGLIO POLISTIROLO \n\n\n\n");
    printf("1)  -> Zero posizione motori\n\n");
    printf("2)  -> Taglia\n\n");
    printf("3)  -> Test correzione filo\n\n");
    printf("ESC -> Esci\n\n");
    printf("Scelta:");
    scelta=getchar();
    switch (scelta)
    {
      case 49:
	      //menu_posizionamento();
	      break;
      case 50:
	      //taglia();
	      break;
      case 51:
        //test_filo();
        break;
      case 27:
	      return;
    }
  }
}
*/
//==================== POSIZIONAMENTO =====================================
/*void menu_posizionamento(void)
{
  int scelta;
  for (;;)
  {
    clrscr();
    scelta =5;
    printf("MENU POSIZIONAMENTO MANUALE ESTREMITA' FILO CALDO\n\n\n\n");
    printf("1)  -> Regola posizione motore radice     X\n\n");
    printf("2)  -> Regola posizione motore estremita' X\n\n");
    printf("3)  -> Regola posizione motore radice     Y\n\n");
    printf("4)  -> Regola posizione motore estremita' Y\n\n");
    printf("5)  -> Regola posizione motori            X\n\n");
    printf("6)  -> Regola posizione motori            Y\n\n");

    printf("ESC -> Esci\n\n");
    printf("\n\n\nATTENZIONE AL FINECORSA!!!!!!!!!!!\n\n\n\n\n\n");
    scelta=getch();
    switch (scelta)
    {
      case 49:
	      reg_mx_rad();
	      break;
      case 50:
	      reg_mx_est();
	      break;
      case 51:
	      reg_my_rad();
	      break;
      case 52:
	      reg_my_est();
	      break;
      case 53:
        reg_mx();
        break;
      case 54:
        reg_my();
        break;
      case 27:
	      return;
    }

  }
}
*/
//===================== ELABORAZIONE NACA ======================================
void elabora()
{
  int i, npc,nppc, conf;
  float YTr[400], YCr[400], DYCr[400], XDDr[400], XCCr[400];
  float YTe[400], YCe[400], DYCe[400], XDDe[400], XCCe[400];
  float LERr, TEANGr, delthr, thetr;
  float LERe, TEANGe, delthe, thete;
  char nomefile[255];



// --------------- PROFILO RADICE --------------------
  delthr=M_PI/(NPP-1);
    for (i=0;i<NPP;i++) {
	XDDr[i]=0.5-0.5*cos(delthr*(i));
      }
  delthr=M_PI/(NP-1);
  for (i=0;i<NP;i++) {
    XCCr[i]=0.5-0.5*cos(delthr*i);
  }
  if (MMr==0) {
    NP=NPP;
    for (i=0;i<NP;i++) {
      XCCr[i]=XDDr[i];
    }
  }
  MCr=(float)(MMr)/100;
  PCr=(float)(PPr)/10;
  TCr=(float)(TOCr)/100;
  for(i=0;i<NP;i++)
  {
    YTr[i]=TCr*(1.4845*sqrt(XCCr[i])-0.63*XCCr[i]-1.758*XCCr[i]*XCCr[i]+1.4215*pow(XCCr[i],3)-0.5075*pow(XCCr[i],4));
    if(MCr==0) {
      YCr[i]=0.0;
      DYCr[i]=0.0;}
    else if(XCCr[i]>PCr) {
      YCr[i]=MCr/pow((1-PCr),2)*(1-2*PCr+2*PCr*XCCr[i]-pow(XCCr[i],2));
      DYCr[i]=2*MCr/pow((1-PCr),2)*(PCr-XCCr[i]);}
    else{
      YCr[i]=MCr/pow(PCr,2)*(2*PCr*XCCr[i]-pow(XCCr[i],2));
      DYCr[i]=2*MCr/pow(PCr,2)*(PCr-XCCr[i]);
    }
  }
  LERr=1.1019*pow(TCr,2);
  TEANGr=2*atan(1.16925*TCr);
  DESIGr=MMr*1000+PPr*100+TOCr;
// --------------- PROFILO ESTREMITA --------------------
/*
  delthe=M_PI/(NPP-1);
    for (i=0;i<NPP;i++) {
	XDDe[i]=0.5-0.5*cos(delthe*(i));
      }
  delthe=M_PI/(NP-1);
  for (i=0;i<NP;i++) {
    XCCe[i]=0.5-0.5*cos(delthe*i);
  }
  if (MMe==0) {
    NP=NPP;
    for (i=0;i<NP;i++) {
      XCCe[i]=XDDe[i];
    }
  }
  MCe=(float)(MMe)/100;
  PCe=(float)(PPe)/10;
  TCe=(float)(TOCe)/100;
  for(i=0;i<NP;i++) {
    YTe[i]=TCe*(1.4845*sqrt(XCCe[i])-0.63*XCCe[i]-1.758*XCCe[i]*XCCe[i]+1.4215*pow(XCCe[i],3)-0.5075*pow(XCCe[i],4));
    if(MCe==0) {
      YCe[i]=0.0;
      DYCe[i]=0.0;}
    else if(XCCe[i]>PCe) {
      YCe[i]=MCe/pow((1-PCe),2)*(1-2*PCe+2*PCe*XCCe[i]-pow(XCCe[i],2));
      DYCe[i]=2*MCe/pow((1-PCe),2)*(PCe-XCCe[i]);}
    else{
      YCe[i]=MCe/pow(PCe,2)*(2*PCe*XCCe[i]-pow(XCCe[i],2));
      DYCe[i]=2*MCe/pow(PCe,2)*(PCe-XCCe[i]);
    }
  }
  LERe=1.1019*pow(TCe,2);
  TEANGe=2*atan(1.16925*TCe);
  DESIGe=MMe*1000+PPe*100+TOCe;
*/
// generazione dei punti del profilo unitario

//*******+++++++++++++++++++++ R A D I C E +++++++++++++++++++++++++++

   for (i=0;i<NP;i++) {
    thetr = atan(DYCr[i]);
    XUr[i]=(XCCr[i]-YTr[i]*sin(thetr));
    YUr[i]=(YCr[i]+YTr[i]*cos(thetr));
    XLr[i]=(XCCr[i]+YTr[i]*sin(thetr));
    YLr[i]=(YCr[i]-YTr[i]*cos(thetr));
    }

//*******+++++++++++++++++ E S T R E M I T A ++++++++++++++++++++++++++
/*
   for (i=0;i<NP;i++) {
    thete = atan(DYCe[i]);
    XUe[i]=(XCCe[i]-YTe[i]*sin(thete));
    YUe[i]=(YCe[i]+YTe[i]*cos(thete));
    XLe[i]=(XCCe[i]+YTe[i]*sin(thete));
    YLe[i]=(YCe[i]-YTe[i]*cos(thete));
    }
*/
//************************ ESPORTAZIONE SU FILE ***********************

   //clrscr();
   printf("\n\nDo you care to save the .dat unit profile? [1/0]:");
   scanf("%d",&conf);
   if (conf==1)
   {
    printf("\nFilename: ");
    scanf("%s",nomefile);
    output_file=fopen(nomefile,"w");
    if(output_file==NULL)
    {
      printf("\nIt was impossible to open the requested file!");
      return;
    }
    for (i=NP-1;i>=0;i--)
    {
     fprintf(output_file,"%f  %f\n",XUr[i], YUr[i]);
    }
    for (i=0;i<NP;i++)
    {
     fprintf(output_file,"%f  %f\n",XLr[i], YLr[i]);
    }
    fprintf(output_file,"1000");
    fclose(output_file);
   }
/*
   printf("\n\nVuoi salvare su file il profilo unitario estremita'? [1/0]:");
   scanf("%d",&conf);
   if (conf==1)
   {
    printf("\nImmettere nome file: ");
    scanf("%s",nomefile);
    output_file=fopen(nomefile,"w");
    if(output_file==NULL)
    {
      printf("\nImpossibile aprire il file");
      return;
    }
    for (i=NP-1;i>=0;i--)
    {
     fprintf(output_file,"%f  %f\n",XLe[i], YLe[i]);
    }
    for (i=0;i<NP;i++)
    {
     fprintf(output_file,"%f  %f\n",XUe[i], YUe[i]);
    }
    fprintf(output_file,"1000");
    fclose(output_file);
   }
*/
}

//========================= V I D E O ==========================================
/*void output_video(void)
{
  int i, vm, xmax, ymax,dx,dy, smx, smy, stepx, stepy;
  int gdriver=DETECT,mode,errorcode;
  float dxu, dyu, dxl, dyl, d, p;
  float XU_rot, YU_rot, XL_rot, YL_rot, sv;
  float XUrv[400], YUrv[400], XLrv[400], YLrv[400];
  float XUev[400], YUev[400], XLev[400], YLev[400];

  printf("\n\nImmettere la lunghezza della corda della radice: ");
  scanf("%f",&cora);
  printf("\n\nImmettere la lunghezza della corda di estremita': ");
  scanf("%f",&coes);
  printf("\n\nImmettere lo svergolamento di estremita': ");
  scanf("%f",&sver);
  sver=sver*M_PI/180;
  cs=0;
  if (sver!=0)
  {
    printf("\n\nCentro di svergolamento [es. 0 BA, 25 Fuoco, 100 BF]: ");
    scanf("%f",&cs);
    cs=cs/100;
  }
  sv=sver*(-1);

  initgraph(&gdriver,&mode,"d:\borlandc\bgi");
  errorcode=graphresult();
  if (errorcode!= 0)
  {
    printf("Errore nella funzione grafica: %s\n",grapherrormsg(errorcode));
    printf("Premere un tasto per uscire:");
    getch();
    return;
  }

   xmax=getmaxx()-1;
   ymax=getmaxy()-1;
   dx=xmax/10;
   dy=ymax/10;
   printf("xmax %d      ymax %d",xmax,ymax);

  //*******+++++++++++++++++ R A D I C E ++++++++++++++++++++++

   for (i=0;i<NP;i++) {
    XUrv[i]=XUr[i]*(float)xmax;
    YUrv[i]=-YUr[i]*(float)xmax+(float)ymax/2;
    XLrv[i]=XLr[i]*(float)xmax;
    YLrv[i]=-YLr[i]*(float)xmax+(float)ymax/2;
    }

  //vga_setcolor(2);
  setcolor(2);
  // griglia verticale e orizzontale 
  for (i=0;i<=xmax;i+=dx){
    //vga_drawline(i,0,i,ymax);}
    line(i,0,i,ymax);}
  for(i=0;i<=ymax/2;i+=dy){
    //vga_draw
    line(0,-i+ymax/2,xmax,-i+ymax/2);
    //vga_draw
    line(0,i+ymax/2,xmax,i+ymax/2);
  }
  //vga_
  setcolor(4);

  // disegno profilo radice 
  for (i=0;i<(NP-1);i++)
  {
   //vga_draw
   line(XUrv[i],YUrv[i],XUrv[i+1],YUrv[i+1]);
   //vga_draw
   line(XLrv[i],YLrv[i],XLrv[i+1],YLrv[i+1]);
  }
//*******+++++++++++++++++ E S T R E M I T A ++++++++++++++++++++++++++

   for (i=0;i<NP;i++)
   {
    XUev[i]=XUe[i]-cs;
    YUev[i]=-YUe[i];
    XLev[i]=XLe[i]-cs;
    YLev[i]=-YLe[i];
   }

// ****************** svergolamento di estremita **********************
   if(sv!=0)
   {
    for (i=0;i<NP;i++)
     {
      XU_rot=(XUev[i])*(float)cos(sv)+(YUev[i])*(float)sin(sv);
      XL_rot=(XLev[i])*(float)cos(sv)+(YLev[i])*(float)sin(sv);
      YU_rot=(-XUev[i])*(float)sin(sv)+(YUev[i])*(float)cos(sv);
      YL_rot=(-XLev[i])*(float)sin(sv)+(YLev[i])*(float)cos(sv);

      XUev[i]=XU_rot*((float)xmax*coes/cora)+(b_mezzi*tan(freccia)+cs*coes+cora/4-coes/4)*(float)xmax/cora;
      YUev[i]=YU_rot*((float)xmax*coes/cora)+ymax/2;
      XLev[i]=XL_rot*((float)xmax*coes/cora)+(b_mezzi*tan(freccia)+cs*coes+cora/4-coes/4)*(float)xmax/cora;
      YLev[i]=YL_rot*((float)xmax*coes/cora)+ymax/2;
     }
   }
   else
   {
    for (i=0;i<NP;i++)
     {
      XUev[i]=XUev[i]*((float)xmax*coes/cora)+(b_mezzi*tan(freccia)+cs*coes+cora/4-coes/4)*(float)xmax/cora;
      YUev[i]=YUev[i]*((float)xmax*coes/cora)+ymax/2;
      XLev[i]=XLev[i]*((float)xmax*coes/cora)+(b_mezzi*tan(freccia)+cs*coes+cora/4-coes/4)*(float)xmax/cora;
      YLev[i]=YLev[i]*((float)xmax*coes/cora)+ymax/2;
     }

   }
  //vga_
  setcolor(4);

  // disegno profilo esterno 
  for (i=0;i<(NP-1);i++) {
   //vga_draw
   line(XUev[i],YUev[i],XUev[i+1],YUev[i+1]);
   //vga_draw
   line(XLev[i],YLev[i],XLev[i+1],YLev[i+1]);
  }
   line(XUev[0],YUev[0],XUev[NP-1],YUev[NP-1]);
  // linea di riferimento centrale 
  //vga_
  setcolor(3);
  //vga_draw
  line(0,ymax/2,xmax,ymax/2);


  //================

   //for (;vga_getkey()==0;) {}
   //vga_setmode(TEXT);
   getch();
   closegraph();
//}
} */
//************************ GNUPLOT **************************************
void output_gnuplot(void)
{
  int i, vm, xmax, ymax,dx,dy, smx, smy, stepx, stepy;
  float dxu, dyu, dxl, dyl, d, p;
  char nomefile[255];

  printf("\nFilename: ");
  scanf("%s",nomefile);
  output_file=fopen(nomefile,"w");
  if(output_file==NULL)
  {
    printf("\nIt was impossible to open the requested file!");
    return;
  }

  for (i=0;i<NP;i++)
  {
    fprintf(output_file,"%f	%f\n",XUr[i],YUr[i]);
  }
  for (i=0;i<NP;i++)
  {
    fprintf(output_file,"%f	%f\n",XLr[i],YLr[i]);
  }
  fclose(output_file);
}
  //************************* D X F *****************************************
void output_dxf(void)
{
  int i, sps=2, vm, xmax, ymax,dx,dy, smx, smy, stepx, stepy;
  float dxu, dyu, dxl, dyl, d, p;
  float XUrd[400], YUrd[400], XLrd[400], YLrd[400];
  char nomefile[255], nomeprof[255];

  printf("\n\nChord lenght: ");
  scanf("%f",&cora);

  printf("\nine thickness [2 is a good choice]: ");
  scanf("%d",&sps);

  printf("\nName to place in the drawing: ");
  scanf("%s",nomeprof);

  printf("\nFile name: ");
  scanf("%s",nomefile);

  output_file=fopen(nomefile,"w");
  if(output_file==NULL) {
    printf("\nImpossible to open the file!");
    system("sleep 2");
    return;
  }
  fprintf(output_file,"0\nSECTION\n2\nHEADER\n9\n");
  fprintf(output_file,"$LIMMIN\n10\n0.000000\n20\n0.000000\n9\n");
  fprintf(output_file,"$LIMMAX\n10\n100.000000\n20\n50.000000\n9\n");
  fprintf(output_file,"$EXTMIN\n10\n0.000000\n20\n0.000000\n9\n");
  fprintf(output_file,"$EXTMAX\n10\n100.000000\n20\n50.000000\n9\n");
  fprintf(output_file,"$ANGBASE\n50\n0.000000\n9\n");
  fprintf(output_file,"$ANGDIR\n70\n0\n9\n");
  fprintf(output_file,"$INSUNITS\n70\n4\n9\n");
  fprintf(output_file,"$DIMALT\n70\n4\n9\n");
  fprintf(output_file,"$DIMLUNIT\n70\n2\n9\n");
  fprintf(output_file,"$DIMASZ\n40\n3.000000\n9\n");
  fprintf(output_file,"$DIMTXT\n40\n5.000000\n9\n");
  fprintf(output_file,"$DIMRND\n40\n0.010000\n9\n");
  fprintf(output_file,"$DIMEXE\n40\n2.000000\n9\n");
  fprintf(output_file,"$DIMEXO\n40\n2.000000\n9\n");
  fprintf(output_file,"$DIMAUNIT\n70\n0\n9\n");
  fprintf(output_file,"$DIMADEC\n70\n2\n9\n");
  fprintf(output_file,"$GRIDUNIT\n10\n0.001000\n20\n0.001000\n9\n");
  fprintf(output_file,"$PLIMMIN\n10\n0.000000\n20\n0.000000\n9\n");
  fprintf(output_file,"$PLIMMAX\n10\n297.000000\n20\n210.000000\n9\n");
  fprintf(output_file,"$PSVPSCALE\n40\n0.936330\n0\nENDSEC\n0\n");
  fprintf(output_file,"SECTION\n2\nTABLES\n0\nTABLE\n2\nLTYPE\n70\n1\n0\n");
  fprintf(output_file,"LTYPE\n2\nCONTINUOUS\n70\n64\n3\nAusgez\n72\n65\n73\n0\n40\n0.000000\n0\nENDTAB\n");
  fprintf(output_file,"0\nTABLE\n2\nLAYER\n70\n1\n0\nLAYER\n2\ndefault\n70\n64\n62\n1\n6\n");
  fprintf(output_file,"CONTINUOUS\n0\nENDTAB\n0\nENDSEC\n0\nSECTION\n2\nBLOCKS\n0\nENDSEC\n0\nSECTION\n2\nENTITIES\n");
  for (i=0;i<NP;i++)
  {
    XUrd[i]=XUr[i]*cora+(297-cora)/2;
    YUrd[i]=YUr[i]*cora+105;
    XLrd[i]=XLr[i]*cora+(297-cora)/2;
    YLrd[i]=YLr[i]*cora+105;
  }
  for (i=0;i<(NP-1);i++) {
    fprintf(output_file,"0\nLINE\n8\ndefault\n6\nCONTINUOUS\n");
    fprintf(output_file,"10\n%f\n20\n%f\n11\n%f\n21\n%f\n",XUrd[i],YUrd[i],XUrd[i+1],YUrd[i+1]);
    fprintf(output_file,"39\n%d\n62\n0\n",sps);
  }
  for (i=0;i<(NP-1);i++)
  {
    fprintf(output_file,"0\nLINE\n8\ndefault\n6\nCONTINUOUS\n");
    fprintf(output_file,"10\n%f\n20\n%f\n11\n%f\n21\n%f\n",XLrd[i],YLrd[i],XLrd[i+1],YLrd[i+1]);
    fprintf(output_file,"39\n%d\n62\n0\n",sps);
  }

  fprintf(output_file,"0\nLINE\n8\ndefault\n6\nDASH\n");
  fprintf(output_file,"10\n%f\n20\n%f\n11\n%f\n21\n%f\n",XLrd[0],YLrd[0],XLrd[NP-1],YLrd[0]);
  fprintf(output_file,"39\n1\n62\n0\n");

  fprintf(output_file,"0\nTEXT\n8\ndefault\n6\nCONTINUOUS\n10\n100.000000\n20\n180.000000\n40\n10\n50\n0.000000\n72\n0\n7\nRomans#1.000000#6.000000\n1\n%s\n39\n2\n62\n0\n",nomeprof);
  fprintf(output_file,"0\nENDSEC\n0\nEOF");
  fclose(output_file);
  return;
}
  //***************************** C N C ****************************************
/*void output_cnc_8051()
{
  int i, vm, xmax, ymax,dx,dy, smx, smy, stepx, stepy;
  float dxu, dyu, dxl, dyl, d, p;
  float XUrd[400], YUrd[400], XLrd[400], YLrd[400];
  float XUed[400], YUed[400], XLed[400], YLed[400];
    // output file per CNC 
    // l'output per CNC viene fatto considerando 200 punti
  printf("\nSTEP MOTORE X: ");
  scanf("%d",&smx);
  printf("\nSTEP MOTORE Y: ");
  scanf("%d",&smy);
  printf("\nPASSO VITI  P: ");
  scanf("%lf",&p);
  if (NP!=201){NP=201;};
  if(NPP!=201){NPP=201;};
  elabora();
  output_file=fopen("./profilo.cnc","w");
  if(output_file==NULL) {
    printf("\nImpossibile aprire il file");
    exit(1);
  }
  output_file1=fopen("./pr_p.cnc","w");
  if(output_file==NULL) {
    printf("\nImpossibile aprire il file");
    exit(1);
  }
  for (i=0;i<NP;i++)
  {
    XUrd[i]=XUr[i]*cora;
    YUrd[i]=YUr[i]*cora;
    XLrd[i]=XLr[i]*cora;
    YLrd[i]=YLr[i]*cora;
  }
  fprintf(output_file," .org h'9000\n");
  fprintf(output_file," .db 0Ah\n");
  fprintf(output_file," .db 09h\n");
  fprintf(output_file," .db 05h\n");
  fprintf(output_file," .db 06h\n");
  for (i=0;i<17;i++)
  {
    fprintf(output_file," .db 00h\n");
  }
  for (i=NP-2;i>(-1);i--)
  {
    dxu=XUr[i+1]-XUr[i];
    if (dxu<0)
    {
      dxu=dxu*(-1)+128;
    }
    fprintf(output_file1,"%f        %f        %f        %f\n",XUrd[i+1],XUrd[i],YUrd[i+1],YUrd[i]);
    stepx=(int)(dxu/(float)p*(float)smx);
    if (stepx<0)
	 {
	  stepx=stepx*(-1)+128;
	 }
    fprintf(output_file," .db d'%d  ;stepx U tratto %d\n",stepx,i);
    dyu=YUr[i]-YUr[i+1];
    stepy=(int)(dyu/(float)p*(float)smy);
    if (stepy<0)
	 {
	  stepy=stepy*(-1)+128;
	 }
      fprintf(output_file," .db d'%d  ;stepy U\n",stepy);
    }
    for (i=0;i<(NP-1);i++)
    {
    dxl=(XLr[i]-XLr[i+1]);
    stepx=(int)(dxl/(float)p*(float)smx);
    if (stepx<0)
    {
	   stepx=stepx*(-1)+128;
	 }
    fprintf(output_file," .db d'%d    ;stepx L tratto %d\n",stepx,i);
    dyl=YLr[i+1]-YLr[i];
    stepy=(int)(dyl/(float)p*(float)smy);
    if (stepy<0)
	 {
	  stepy=stepy*(-1)+128;
	 }
    fprintf(output_file," .db d'%d    ;stepy L\n",stepy);
    }
    fclose(output_file);
    fclose(output_file1);
}
//****************************** CNC PP *************************************
void output_cnc_pp()
{
  int i, stepxr, stepyr, stepxe, stepye;
  float dxur, dyur, dxlr, dylr;
  float dxue, dyue, dxle, dyle;
  float XU_rot, YU_rot, XL_rot, YL_rot;
  float lf, x, y, a, k;
  float p_xr, p_yr, p_xe, p_ye;
  float *p_xur, *p_yur, *pt_xur, *pt_yur;
  float *p_xlr, *p_ylr, *pt_xlr, *pt_ylr;
  float *p_xue, *p_yue, *pt_xue, *pt_yue;
  float *p_xle, *p_yle, *pt_xle, *pt_yle;
  float XUrc[400], YUrc[400], XLrc[400], YLrc[400];
  float XUec[400], YUec[400], XLec[400], YLec[400];

  if ((p_xur = (float *) malloc(NP*sizeof(float))) == NULL)
  {
   printf("Not enough memory to allocate buffer\n");
   return;  // terminate program if out of memory 
  }
  if ((p_yur = (float *) malloc(NP*sizeof(float))) == NULL)
  {
   printf("Not enough memory to allocate buffer\n");
   return;  // terminate program if out of memory 
  }
  if ((p_xlr = (float *) malloc(NP*sizeof(float))) == NULL)
  {
   printf("Not enough memory to allocate buffer\n");
   return;  // terminate program if out of memory 
  }
  if ((p_ylr = (float *) malloc(NP*sizeof(float))) == NULL)
  {
   printf("Not enough memory to allocate buffer\n");
   return;  // terminate program if out of memory 
  }
  if ((p_xue = (float *) malloc(NP*sizeof(float))) == NULL)
  {
   printf("Not enough memory to allocate buffer\n");
   return;  // terminate program if out of memory 
  }
  if ((p_yue = (float *) malloc(NP*sizeof(float))) == NULL)
  {
   printf("Not enough memory to allocate buffer\n");
   return;  // terminate program if out of memory 
  }
  if ((p_xle = (float *) malloc(NP*sizeof(float))) == NULL)
  {
   printf("Not enough memory to allocate buffer\n");
   return;  // terminate program if out of memory 
  }
  if ((p_yle = (float *) malloc(NP*sizeof(float))) == NULL)
  {
   printf("Not enough memory to allocate buffer\n");
   return;  // terminate program if out of memory 
  }

  pt_xur=p_xur;
  pt_yur=p_yur;
  pt_xlr=p_xlr;
  pt_ylr=p_ylr;
  pt_xue=p_xue;
  pt_yue=p_yue;
  pt_xle=p_xle;
  pt_yle=p_yle;

  clrscr();
  printf("\n\n\n\nESPORTAZIONE FILE DATI PROFILO DA TAGLIARE VIA PORTA PARALLELA\n\n");
  printf("\n\nImmettere la lunghezza della corda della radice: ");
  scanf("%f",&cora);
  printf("\n\nImmettere la lunghezza della corda di estremita': ");
  scanf("%f",&coes);
  printf("\n\nImmettere lo svergolamento di estremita': ");
  scanf("%f",&sver);
  sver=sver*M_PI/180;
  cs=0;
  if (sver!=0)
  {
    printf("\n\nCentro di svergolamento [es. 0 BA, 25 Fuoco, 100 BF]: ");
    scanf("%f",&cs);
    cs=cs/100;
  }
  clrscr();

  printf("\n\nIMMISSIONE DATI GEOMETRICI SEMIALA\n\n");
  printf("\n\n\n\nFreccia [in gradi]: ");
  scanf("%f",&freccia);
  freccia=freccia*M_PI/180;
  printf("\n\Lunghezza ala [in mm]: ");
  scanf("%f",&b_mezzi);

  clrscr();

  printf("\n\nIMMISSIONE DATI MACCHINA\n\n");

  printf("\nSTEP MOTORE XR: ");
  scanf("%d",&smxr);
  printf("\nSTEP MOTORE YR: ");
  scanf("%d",&smyr);
  printf("\nSTEP MOTORE XE: ");
  scanf("%d",&smxe);
  printf("\nSTEP MOTORE YE: ");
  scanf("%d",&smye);
  printf("\nPASSO VITI  P: ");
  scanf("%f",&p);
  printf("\nCORREZIONE FILO MINIMA cfmin[mm]: ");
  scanf("%f",&cf_min);
  printf("\nCORREZIONE FILO MASSIMA cfmax[mm]: ");
  scanf("%f",&cf_max);
  printf("\nLUNGHEZZA FILO[MM]: ");
  scanf("%f",&lf);

//correzione calcolata all'estremit
  cf_es=cf_min+(cf_max-cf_min)/cora*2*(cora-coes);


// RIORDINO PUNTI PUNTI PROFILO UNITARIO
// intradosso ed extradosso radice ed estremita'
// partendo dal bordo di attacco a quello di fuga
  for (i=0;i<NP;i++)
  {
    XUrc[i]=XUr[i]*cora;
    YUrc[i]=YUr[i]*cora;
    XLrc[i]=XLr[i]*cora;
    YLrc[i]=YLr[i]*cora;

// sottraggo cs per ruotare intorno al centro di svergolamento
    XUec[i]=XUe[i]-cs;
    YUec[i]=YUe[i];
    XLec[i]=XLe[i]-cs;
    YLec[i]=YLe[i];
  }
// **************** rotazione del profilo di estremita' *******************
    if(sver!=0)
    {
      for(i=0;i<NP;i++)
      {
        XU_rot=(XUec[i])*cos(sver)+(YUec[i])*sin(sver);
        XL_rot=(XLec[i])*cos(sver)+(YLec[i])*sin(sver);
        YU_rot=(-XUec[i])*sin(sver)+(YUec[i])*cos(sver);
        YL_rot=(-XLec[i])*sin(sver)+(YLec[i])*cos(sver);
// fattore di scala e ritraslazione sulla linea del 1/4 alare (freccia nulla)
// ma possibile diedro neg se sver a picchiare e viceversa se cs <> 1/4

        XUec[i]=(XU_rot+cs)*coes;
        YUec[i]=YU_rot*coes;
        XLec[i]=(XL_rot+cs)*coes;
        YLec[i]=YL_rot*coes;
      }
    }
    else
    {
      for(i=0;i<NP;i++)
      {
        XUec[i]=(XUec[i]+cs)*coes;
        YUec[i]=YUec[i]*coes;
        XLec[i]=(XLec[i]+cs)*coes;
        YLec[i]=YLec[i]*coes;
      }
    }


  if((output_file=fopen("./profilo.pp","w"))==NULL)
  {
   printf("Impossibile aprire file profilo.pp");
  }
  else{
  for (i=0;i<NP;i++)
  {

    fprintf(output_file,"XUe %d   %f YUe    %f\n",i,XUec[i],YUec[i]);
    fprintf(output_file,"XLe %d   %f YLe    %f\n\n",i,XLec[i],YLec[i]);

  }
  fclose(output_file);
  }

// correzione coordinate punti per irraggiamento filo caldo extradosso

// primo punto radice
if (cf_max!=0)
 {
  dxur=XUrc[1]-XLrc[1];
  dyur=YUrc[1]-YLrc[1];
  if (dxur==0)
  {
    *p_xur=XUrc[0]-cf_min;
    *p_xlr=*p_xur;
    *p_yur=YUrc[0];
    *p_ylr=*p_yur;
  }
  else
  {
    if (dxur<0)
    {
      a=atan(dyur/(-dxur));
      *p_xur=XUrc[0]-cf_min*sin(a);
      *p_yur=YUrc[0]-cf_min*cos(a);
      *p_xlr=*p_xur;
      *p_ylr=*p_yur;
    }
    else
    {
      a=atan(dyur/dxur);
      *p_xur=XUrc[0]-cf_min*sin(a);
      *p_yur=YUrc[0]+cf_min*cos(a);
      *p_xlr=*p_xur;
      *p_ylr=*p_yur;
    }
  }

// primo punto estremit

  dxue=XUec[1]-XLec[1];
  dyue=YUec[1]-YLec[1];
  if (dxue==0)
  {
    *p_xue=XUec[0]-cf_es;
    *p_xle=*p_xue;
    *p_yue=YUec[0];
    *p_yle=*p_yue;
  }
  else
  {
    if (dxue<0)
    {
      a=atan(dyue/(-dxue));
      *p_xue=XUec[0]-cf_es*sin(a);
      *p_yue=YUec[0]-cf_es*cos(a);
      *p_xle=*p_xue;
      *p_yle=*p_yue;
    }
    else
    {
      a=atan(dyue/dxue);
      *p_xue=XUec[0]-cf_es*sin(a);
      *p_yue=YUec[0]+cf_es*cos(a);
      *p_xle=*p_xue;
      *p_yle=*p_yue;
    }
  }

  p_xur++;
  p_yur++;
  p_xue++;
  p_yue++;

// punti dall'1 all'NP-2
  for (i=1;i<NP-1;i++)
  {
// punto i radice
    dxur=XUrc[i+1]-XUrc[i-1];
    dyur=YUrc[i+1]-YUrc[i-1];
    if (dxur==0)
    {
      if(dyur>0)
      {
        *p_xur=XUrc[i]-cf_min;
      }
      else
      {
        *p_xur=XUrc[i]+cf_min;
      }

    }
    else
    {
      a=atan(dyur/dxur);
      *p_xur=XUrc[i]-cf_min*sin(a);
      *p_yur=YUrc[i]+cf_min*cos(a);
    }
// punto i estremit

    dxue=XUec[i+1]-XUec[i-1];
    dyue=YUec[i+1]-YUec[i-1];
    if (dxue==0)
    {
      if(dyue>0)
      {
        *p_xue=XUec[i]-cf_es;
      }
      else
      {
        *p_xue=XUec[i]+cf_es;
      }
    }
    else
    {
      a=atan(dyue/dxue);
      *p_xue=XUec[i]-cf_es*sin(a);
      *p_yue=YUec[i]+cf_es*cos(a);
    }

    p_xur++;
    p_yur++;
    p_xue++;
    p_yue++;

  }

// correzione coordinate punti per irraggiamento filo caldo intradosso
// punti dall'1 all'NP-2

  p_xlr++;
  p_ylr++;
  p_xle++;
  p_yle++;


  for (i=1;i<NP-1;i++)
  {

// punto i radice
    dxlr=XLrc[i+1]-XLrc[i-1];
    dylr=YLrc[i+1]-YLrc[i-1];
    if (dxlr==0)
    {
      if(dylr>0)
      {
        *p_xlr=XLrc[i]+cf_min;
      }
      else
      {
        *p_xlr=XLrc[i]-cf_min;
      }
    }
    else
    {
      a=atan(dylr/dxlr);
      *p_xlr=XLrc[i]+cf_min*sin(a);
      *p_ylr=YLrc[i]-cf_min*cos(a);
    }

// punto i estremit
    dxle=XLec[i+1]-XLec[i-1];
    dyle=YLec[i+1]-YLec[i-1];
    if (dxle==0)
    {
      if(dyle>0)
      {
        *p_xle=XLec[i]+cf_es;
      }
      else
      {
        *p_xle=XLec[i]-cf_es;
      }
    }
    else
    {
      a=atan(dyle/dxle);
      *p_xle=XLec[i]+cf_es*sin(a);
      *p_yle=YLec[i]-cf_es*cos(a);
    }

    p_xlr++;
    p_ylr++;
    p_xle++;
    p_yle++;

  }


// calcolo punto BF come intersezione rette passanti tra i punti
// corretti filo NP-2 e NP-3
// si dovrebbero usare i punti NP-2 e NP-3 del profilo corretto
//ma cosi si ottiene un gradino al BF che taglia in modo + definito

// punto NP-1 radice

  x=YLrc[NP-3]-YUrc[NP-3];
  x=x+XUrc[NP-3]*(YUrc[NP-2]-YUrc[NP-3])/(XUrc[NP-2]-XUrc[NP-3]);
  x=x-XLrc[NP-3]*(YLrc[NP-2]-YLrc[NP-3])/(XLrc[NP-2]-XLrc[NP-3]);
  x=x/((YUrc[NP-2]-YUrc[NP-3])/(XUrc[NP-2]-XUrc[NP-3])-(YLrc[NP-2]-YLrc[NP-3])/(XLrc[NP-2]-XLrc[NP-3]));
  *p_xur=x;
  *p_xlr=x;

  *p_yur=YUrc[NP-3]+(x-XUrc[NP-3])*(YUrc[NP-2]-YUrc[NP-3])/(XUrc[NP-2]-XUrc[NP-3]);
  *p_ylr=YUrc[NP-1];

// punto NP-1 estremita
  x=YLec[NP-3]-YUec[NP-3];
  x=x+XUec[NP-3]*(YUec[NP-2]-YUec[NP-3])/(XUec[NP-2]-XUec[NP-3]);
  x=x-XLec[NP-3]*(YLec[NP-2]-YLec[NP-3])/(XLec[NP-2]-XLec[NP-3]);
  x=x/((YUec[NP-2]-YUec[NP-3])/(XUec[NP-2]-XUec[NP-3])-(YLec[NP-2]-YLec[NP-3])/(XLec[NP-2]-XLec[NP-3]));
  *p_xue=x;
  *p_xle=x;

  *p_yue=YUec[NP-3]+(x-XUec[NP-3])*(YUec[NP-2]-YUec[NP-3])/(XUec[NP-2]-XUec[NP-3]);
  *p_yle=YUec[NP-1];

  p_xur=pt_xur;
  p_yur=pt_yur;
  p_xlr=pt_xlr;
  p_ylr=pt_ylr;

  p_xue=pt_xue;
  p_yue=pt_yue;
  p_xle=pt_xle;
  p_yle=pt_yle;


  for(i=0;i<NP;i++)
  {
    XUrc[i]=*p_xur;
    YUrc[i]=*p_yur;
    XLrc[i]=*p_xlr;
    YLrc[i]=*p_ylr;

    XUec[i]=*p_xue;
    YUec[i]=*p_yue;
    XLec[i]=*p_xle;
    YLec[i]=*p_yle;

    p_xur++;
    p_yur++;
    p_xlr++;
    p_ylr++;

    p_xue++;
    p_yue++;
    p_xle++;
    p_yle++;
  }
 }
    free(p_xur);
    free(p_yur);
    free(p_xlr);
    free(p_ylr);

    free(p_xue);
    free(p_yue);
    free(p_xle);
    free(p_yle);

/*
  for (i=0;i<NP;i++)
  {
    printf("XUr %d   %f\n",i,XUr[i]);
    printf("YUr %d   %f\n\n",i,YUr[i]);
    printf("XLe %d   %f\n",i,XLe[i]);
    printf("YLe%d   %f\n\n\n",i,YLe[i]);
    getchar();

  }



// correzione traiettoria filo che tiene conto della differenza tra
// lunghezza filo e lunghezza semiala

  for (i=0;i<NP;i++)
  {
    p_yr=YUec[i]-(YUec[i]-YUrc[i])/b_mezzi*(b_mezzi+lf)*0.5;
    p_xr=XUec[i]-(XUec[i]-XUrc[i])/b_mezzi*(b_mezzi+lf)*0.5;
    p_ye=YUec[i]+(YUec[i]-YUrc[i])/b_mezzi*(-b_mezzi+lf)*0.5;
    p_xe=XUec[i]+(XUec[i]-XUrc[i])/b_mezzi*(-b_mezzi+lf)*0.5;

    YUrc[i]=p_yr;
    XUrc[i]=p_xr;
    YUec[i]=p_ye;
    XUec[i]=p_xe;

    p_yr=YLec[i]-(YLec[i]-YLrc[i])/b_mezzi*(b_mezzi+lf)*0.5;
    p_xr=XLec[i]-(XLec[i]-XLrc[i])/b_mezzi*(b_mezzi+lf)*0.5;
    p_ye=YLec[i]+(YLec[i]-YLrc[i])/b_mezzi*(-b_mezzi+lf)*0.5;
    p_xe=XLec[i]+(XLec[i]-XLrc[i])/b_mezzi*(-b_mezzi+lf)*0.5;

    YLrc[i]=p_yr;
    XLrc[i]=p_xr;
    YLec[i]=p_ye;
    XLec[i]=p_xe;

  }

/*
   k=XUr[0];

  for (i=0;i<NP;i++)
  {
    XUr[i]=XUr[i]-k;
    XLr[i]=XLr[i]-k;
    XUe[i]=XUe[i]-k;
    XLe[i]=XLe[i]-k;
  }
*/
/*
  if((output_file=fopen("./pr_filo.pp","w"))==NULL)
  {
   printf("Impossibile aprire file profilo.pp");
  }
  else{
  for (i=0;i<NP;i++)
  {

    fprintf(output_file,"XUe %d   %f YUe    %f\n",i,XUe[i],YUe[i]);
    fprintf(output_file,"XLe %d   %f YLe    %f\n\n",i,XLe[i],YLe[i]);

  }
  fclose(output_file);
  }



    for (i=0;i<NP;i++)
  {
    printf("XUr %d   %f\n",i,XUr[i]);
    printf("YUr %d   %f\n\n",i,YUr[i]);
    printf("XLe %d   %f\n",i,XLe[i]);
    printf("YLe%d   %f\n\n\n",i,YLe[i]);
    getch();

  }


// calcolo della lunghezza dei segmenti secondo x e y e riordino in modo da
// avere in ordine i segmenti percorsi partendo dal bordo di fuga
// percorrendo prima l'extradosso

// extradosso  da steps[0] a [NP-2]

  for (i=NP-2;i>(-1);i--)
  {
    dxur=XUrc[i+1]-XUrc[i];
    stepxr=(int)(dxur/p*(float)smxr);
    steps[NP-2-i][0]=stepxr;
    dyur=YUrc[i]-YUrc[i+1];
    stepyr=(int)(dyur/p*(float)smyr);
    steps[NP-2-i][1]=stepyr;
    dxue=XUec[i+1]-XUec[i];
    stepxe=(int)(dxue/p*(float)smxe);
    steps[NP-2-i][2]=stepxe;
    dyue=YUec[i]-YUec[i+1];
    stepye=(int)(dyue/p*(float)smye);
    steps[NP-2-i][3]=stepye;

//    printf("stepxru %d   %d\n",NP-2-i,stepxr);
//    printf("stepyru %d   %d\n\n",NP-2-i,stepyr);
//    printf("stepxeu %d   %d\n",NP-2-i,stepxe);
//    printf("stepyeu %d   %d\n\n\n",NP-2-i,stepye);
//    getchar();

  }

// intradosso



  for (i=0;i<(NP-1);i++)
  {
    dxlr=(XLrc[i]-XLrc[i+1]);
    stepxr=(int)(dxlr/p*(float)smxr);
    steps[NP-2+i+1][0]=stepxr;
    dylr=YLrc[i+1]-YLrc[i];
    stepyr=(int)(dylr/p*(float)smyr);
    steps[NP-2+i+1][1]=stepyr;
    dxle=(XLec[i]-XLec[i+1]);
    stepxe=(int)(dxle/p*(float)smxe);
    steps[NP-2+i+1][2]=stepxe;
    dyle=YLec[i+1]-YLec[i];
    stepye=(int)(dyle/p*(float)smye);
    steps[NP-2+i+1][3]=stepye;

//    printf("stepxrl %d   %d\n",NP-2+i+1,stepxr);
//    printf("stepyrl %d   %d\n\n",NP-2+i+1,stepyr);
//    printf("stepxel %d   %d\n",NP-2+i+1,stepxe);
//    printf("stepyel %d   %d\n\n\n",NP-2+i+1,stepye);
//    getchar();

  }





}
//******************* posizione motore X radice *****************************
/*void reg_mx_rad(void)
{
  int scelta;
  int i;
  clrscr();
  printf("\n\n\n\nMENU regolazione motore X radice\n\n\n\n");
  printf("Fr  Dx Per andare avanti\n\n");
  printf("Pg  Up Per andare avanti veloce\n\n");
  printf("Fr  Sx Per tornare indietro\n\n");
  printf("Pg  Dn Per tornare indietro veloce\n\n");
  printf("ESC Per uscire\n\n");
  for(;;)
  {
    scelta=getch();
    switch (scelta)
    {
      case 75:
	//-------------- andare ant con mxr fine
//	for (i=0;i<4;i++)
//	{
	  m(1,0);
	  delay(2);
//	}
	break;
      case 77:
	//-------------- andare orar con mxr fine
//	for (i=0;i<4;i++)
//	{
	  m(1,1);
	  delay(2);
//	}

	break;
      case 73: // movimentazione veloce
	while (!kbhit())
	{
	  m(1,0);
	  delay(3);
	}
	break;
      case 81:
	while (!kbhit())
	{
	  m(1,1);
	  delay(3);
	}
	break;
      case 27:
	return;
    }
  }
}
//******************* posizione motore X estremita **************************
void reg_mx_est(void)
{
  int scelta,i;
  clrscr();
  printf("\n\n\n\nMENU regolazione motore X estremita'\n\n\n\n");
  printf("Fr Dx Per andare avanti\n\n");
  printf("Pg Up Per andare avanti veloce\n\n");
  printf("Fr Sx Per tornare indietro\n\n");
  printf("Pg Dn Per tornare indietro veloce\n\n");
  printf("ESC  Per uscire\n\n");

  printf("\n\nIl BF dell'estremit deve essere avanzato[+]/arretrato[-] di: %fmm\n",(0.75*(cora-coes)-b_mezzi*tan(freccia)));
  for(;;)
  {
    scelta=getch();
    switch (scelta)
    {
      case 75:
	//-------------- andare ant con mxe   fine
//	for (i=0;i<4;i++)
//	{
	  m(3,0);
	  delay(2);
//	}
		break;
      case 77:
	//-------------- andare orar con mxe fine
//	for (i=0;i<4;i++)
//	{
	  m(3,1);
	  delay(2);
//	}
	break; // movimentazione veloce
      case 73:
	while (!kbhit())
	{
	  m(3,0);
	  delay(3);
	}
	break;
      case 81:
	while (!kbhit())
	{
	  m(3,1);
	  delay(3);
	}
	break;
      case 27:
	return;
    }
  }

}
//******************* posizione motore Y radice  **************************
void reg_my_rad(void)
{
  int scelta,i;
  clrscr();
  printf("\n\n\n\nMENU regolazione motore Y radice\n\n\n\n");
  printf("Fr Su  Per andare avanti\n\n");
  printf("Pg Up  Per andare avanti veloce\n\n");
  printf("Fr Giu Per tornare indietro\n\n");
  printf("Pg Dn  Per tornare indietro veloce\n\n");
  printf("ESC    Per uscire\n\n");

  for(;;)
  {
    scelta=getch();
    switch (scelta)
    {
      case 72:
	//-------------- andare su con myr fine
//	for (i=0;i<4;i++)
//	{
	  m(2,0);
	  delay(2);
//	}
	break;
      case 80:
	//-------------- andare giu' con myr   fine
//	for (i=0;i<4;i++)
//	{
	  m(2,1);
	  delay(2);
//	}
	break;
      case 73: // movimentazione fine veloce
	while (!kbhit())
	{
	  m(2,0);
	  delay(3);
	}
	break;
      case 81:
	while (!kbhit())
	{
	  m(2,1);
	  delay(3);
	}
	break;

      case 27:
	return;
    }
  }

}
//******************* posizione motore Y estremita **************************
void reg_my_est(void)
{
  int scelta,i;
  clrscr();
  printf("\n\n\n\nMENU regolazione motore Y estremita'\n\n\n\n");
  printf("Fr Su  Per andare su lento\n\n");
  printf("Pg Up  Per andare su veloce\n\n");
  printf("Fr Giu Per andare gi lento\n\n");
  printf("Pg Dn  Per andare gi veloce\n\n");
  printf("ESC    Per uscire\n\n");

  for(;;)
  {
    scelta=getch();
    switch (scelta)
    {
      case 72:
	//-------------- andare su con mye
//	for (i=0;i<4;i++)
//	{
	  m(4,0);
	  delay(2);
//	}
	break;
      case 80:
	//-------------- andare giu' con mye
//	for (i=0;i<4;i++)
//	{
	  m(4,1);
	  delay(2);
//	}
	break;
      case 73: // movimentazione veloce
	while (!kbhit())
	{
	  m(4,0);
	  delay(3);
	}
	break;
      case 81:
	while (!kbhit())
	{
	  m(4,1);
	  delay(3);
	}
	break;

      case 27:
	return;
    }
  }

}
//******************* posizione motori X ***********************************
void reg_mx(void)
{
  int scelta;
  int i;
  clrscr();
  printf("\n\n\n\nMENU regolazione motori X\n\n\n\n");
  printf("Fr Dx Per andare avanti\n\n");
  printf("Pg Up Per andare avanti veloce Vmax [Test irraggiamento]\n\n");
  printf("Fr Sx Per tornare indietro\n\n");
  printf("Pg Dn Per tornare indietro veloce\n\n");
  printf("m     Per andare avanti a Vmax/2 [Test irraggiamento]\n\n");
  printf("ESC   Per uscire\n\n");
  for(;;)
  {
    scelta=getch();
    switch (scelta)
    {
      case 75:
	//-------------- andare ant con mx fine
//	for (i=0;i<4;i++)
//	{
	  m(5,0);
	  delay(2);
//	}
	  break;
      case 77:
	//-------------- andare orar con mx fine
//	for (i=0;i<4;i++)
//	{
	  m(5,1);
	  delay(2);
//	}

	  break;
      case 73: // movimentazione veloce
	  while (!kbhit())
	  {
	    m(5,0);
	    delay(3);
	  }
	  break;
      case 81:
	  while (!kbhit())
	  {
	    m(5,1);
	    delay(3);
	  }
	  break;
      case 109:
	  while (!kbhit())
	  {
	    m(5,0);
	    delay(6);
	  }
   	break;
      case 27:
   	return;
    }
  }
}

//******************* posizione motori Y ***********************************
void reg_my(void)
{
  int scelta;
  int i;
  clrscr();
  printf("\n\n\n\nMENU regolazione motori Y\n\n\n\n");
//  printf("\n\n\nVerificare l'esatta posizione delle estremita' del filo;\n\n");
//  printf("Quella esterna dovra' essere a %fmm da quella di radice.\n\n",(0.75*(cora-coes)-(b_mezzi*tan(freccia))));
//  printf("Il posizionamento lungo Y  automatico.\n\n");
  printf("Fr Su Per andare su lento\n\n");
  printf("Pg Up Per andare su veloce\n\n");
  printf("Fr Giu Per andare gi lento\n\n");
  printf("Pg Dn Per andare gi veloce\n\n");
  printf("ESC  Per uscire\n\n");
  for(;;)
  {
    scelta=getch();
    switch (scelta)
    {
      case 72:
	//-------------- andare su con mx fine
//	for (i=0;i<4;i++)
//	{
	  m(6,0);
	  delay(2);
//	}
	break;
      case 80:
	//-------------- andare gi con mx fine
//	for (i=0;i<4;i++)
//	{
	  m(6,1);
	  delay(2);
//	}

	break;
      case 73: // movimentazione veloce
	while (!kbhit())
	{
	  m(6,0);
	  delay(3);
	}
	break;
      case 81:
	while (!kbhit())
	{
	  m(6,1);
	  delay(3);
	}
	break;
      case 27:
	return;
    }
  }
}

//*******************   movimento manuale motori  **************************
void m(int i,int j)         // i=1-4 motore j=0,1 avanti/dietro
{                          // i=5 motori x i=6 motori y
  unsigned char act_stepx, next_stepx, act_stepy, next_stepy;
// 00 11 11 11 = 63
// 11 00 00 00 = 192
// 11 00 11 11 = 207
// 00 11 00 00 = 48
// 11 11 00 11 = 243
// 00 00 11 00 = 12
// 11 11 11 00 = 252
// 00 00 00 11 = 3
// STEP
// my   mx   mye mxe myr mxr
// 6    5    4   3   2   1
// -----------------------
//           0   0   0   0
//           128 32  8   2
//           192 48 12   3
//           64  16  4   1
  switch (i)
  {
    case 1:
      act_stepx=(posiz_motori & 3);
      if (j==0)   //rotazione antioraria
      {
        if (act_stepx==0)
        	next_stepx=1;
        else if (act_stepx==1)
	        next_stepx=3;
        else if (act_stepx==3)
        	next_stepx=2;
        else if (act_stepx==2)
	        next_stepx=0;
      }
      else if (j==1)  // rotazione oraria
      {
        if (act_stepx==0)
	        next_stepx=2;
        else if (act_stepx==2)
	        next_stepx=3;
        else if (act_stepx==3)
	        next_stepx=1;
        else if (act_stepx==1)
	        next_stepx=0;
      }
      posiz_motori=posiz_motori & 252;
      posiz_motori=posiz_motori + next_stepx;
      break;
    case 2:
      act_stepy=(posiz_motori & 12);
      if (j==0)   //rotazione antioraria
      {
        if (act_stepy==0)
        	next_stepy=4;
        else if (act_stepy==4)
	        next_stepy=12;
        else if (act_stepy==12)
        	next_stepy=8;
        else if (act_stepy==8)
	        next_stepy=0;
      }
      else if (j==1)  // rotazione oraria
      {
        if (act_stepy==0)
	        next_stepy=8;
        else if (act_stepy==8)
	        next_stepy=12;
        else if (act_stepy==12)
	        next_stepy=4;
        else if (act_stepy==4)
	        next_stepy=0;
      }
      posiz_motori=posiz_motori & 243;
      posiz_motori=posiz_motori + next_stepy;
      break;
    case 3:
      act_stepx=(posiz_motori & 48);
      if (j==0)   //rotazione antioraria
      {
        if (act_stepx==0)
        	next_stepx=16;
        else if (act_stepx==16)
	        next_stepx=48;
        else if (act_stepx==48)
        	next_stepx=32;
        else if (act_stepx==32)
	        next_stepx=0;
      }
      else if (j==1)  // rotazione oraria
      {
        if (act_stepx==0)
	        next_stepx=32;
        else if (act_stepx==32)
	        next_stepx=48;
        else if (act_stepx==48)
	        next_stepx=16;
        else if (act_stepx==16)
	        next_stepx=0;
      }
      posiz_motori=posiz_motori & 207;
      posiz_motori=posiz_motori + next_stepx;
      break;
    case 4:
      act_stepy=(posiz_motori & 192);
      if (j==0)   //rotazione antioraria
      {
        if (act_stepy==0)
        	next_stepy=64;
        else if (act_stepy==64)
	        next_stepy=192;
        else if (act_stepy==192)
        	next_stepy=128;
        else if (act_stepy==128)
	        next_stepy=0;
      }
      else if (j==1)  // rotazione oraria
      {
        if (act_stepy==0)
	        next_stepy=128;
        else if (act_stepy==128)
	        next_stepy=192;
        else if (act_stepy==192)
	        next_stepy=64;
        else if (act_stepy==64)
	        next_stepy=0;
      }
      posiz_motori=posiz_motori & 63;
      posiz_motori=posiz_motori + next_stepy;
      break;
    case 5:
      act_stepx=(posiz_motori & 3);
      if (j==0)   //rotazione antioraria
      {
        if (act_stepx==0)
        	next_stepx=1;
        else if (act_stepx==1)
	        next_stepx=3;
        else if (act_stepx==3)
        	next_stepx=2;
        else if (act_stepx==2)
	        next_stepx=0;
      }
      else if (j==1)  // rotazione oraria
      {
        if (act_stepx==0)
	        next_stepx=2;
        else if (act_stepx==2)
	        next_stepx=3;
        else if (act_stepx==3)
	        next_stepx=1;
        else if (act_stepx==1)
	        next_stepx=0;
      }
      posiz_motori=posiz_motori & 252;
      posiz_motori=posiz_motori + next_stepx;

      act_stepx=(posiz_motori & 48);
      if (j==0)   //rotazione antioraria
      {
        if (act_stepx==0)
        	next_stepx=16;
        else if (act_stepx==16)
	        next_stepx=48;
        else if (act_stepx==48)
        	next_stepx=32;
        else if (act_stepx==32)
	        next_stepx=0;
      }
      else if (j==1)  // rotazione oraria
      {
        if (act_stepx==0)
	        next_stepx=32;
        else if (act_stepx==32)
	        next_stepx=48;
        else if (act_stepx==48)
	        next_stepx=16;
        else if (act_stepx==16)
	        next_stepx=0;
      }
      posiz_motori=posiz_motori & 207;
      posiz_motori=posiz_motori + next_stepx;
      break;
    case 6:
      act_stepy=(posiz_motori & 12);
      if (j==0)   //rotazione antioraria
      {
        if (act_stepy==0)
        	next_stepy=4;
        else if (act_stepy==4)
	        next_stepy=12;
        else if (act_stepy==12)
        	next_stepy=8;
        else if (act_stepy==8)
	        next_stepy=0;
      }
      else if (j==1)  // rotazione oraria
      {
        if (act_stepy==0)
	        next_stepy=8;
        else if (act_stepy==8)
	        next_stepy=12;
        else if (act_stepy==12)
	        next_stepy=4;
        else if (act_stepy==4)
	        next_stepy=0;
      }
      posiz_motori=posiz_motori & 243;
      posiz_motori=posiz_motori + next_stepy;

      act_stepy=(posiz_motori & 192);
      if (j==0)   //rotazione antioraria
      {
        if (act_stepy==0)
        	next_stepy=64;
        else if (act_stepy==64)
	        next_stepy=192;
        else if (act_stepy==192)
        	next_stepy=128;
        else if (act_stepy==128)
	        next_stepy=0;
      }
      else if (j==1)  // rotazione oraria
      {
        if (act_stepy==0)
	        next_stepy=128;
        else if (act_stepy==128)
	        next_stepy=192;
        else if (act_stepy==192)
	        next_stepy=64;
        else if (act_stepy==64)
	        next_stepy=0;
      }
      posiz_motori=posiz_motori & 63;
      posiz_motori=posiz_motori + next_stepy;
      break;
  }

  outportb(888,posiz_motori);

}

//************************* TAGLIA ******************************************
/*void taglia(void)
{
  int dt, dto, dtv,i, j, xratt, xeatt, yratt, yeatt, xrpr, xepr, yrpr, yepr;
  char dxr, dyr, dxe, dye, scelta;
  float tanxr, tanyr, tanxe, tanye;
  unsigned char seq_xr[4]={0,1,3,2};
  unsigned char seq_yr[4]={0,4,12,8};
  unsigned char seq_xe[4]={0,16,48,32};
  unsigned char seq_ye[4]={0,64,192,128};
  signed char p_xr=0, p_yr=0, p_xe=0, p_ye=0;
  char out_mot, p_mot;

  clrscr();

  printf("\n\n\nVerificare l'esatta posizione delle estremita' del filo;\n\n");
  printf("Quella esterna dovra' essere a %fmm da quella di radice.\n\n",(0.75*(cora-coes)-(b_mezzi*tan(freccia))));
  printf("Il posizionamento lungo Y  automatico.\n\n\n\n");
  printf("Premere invio per azzeramento verticale Y, ESC per uscire\n\n");
  scelta=getch();
  if (scelta==27)
  {
    return;
  }
  dtv=(round(YUe[NP-1]-YUr[NP-1]))/p*smye;

  // verificare qui il giusto verso di taglio !!!!!!!!!!!
  if (dtv>0)
  {
    for (i=0;i<dtv;i++)
    {
      m(4,0);
      delay(3);
    }
  }
  else if (dtv<0)
  {
    dtv=-dtv;
    for (i=0;i<dtv;i++)
    {
      m(4,1);
      delay(3);
    }
  }

  clrscr();

  printf("\n\n\n\nAzzeramento effettuato! Pronto per il taglio.\n\n Premere un tasto per partire, ESC per uscire\n");

  scelta=getch();
  if (scelta==27)
  {
    return;
  }
  //tacca sul BF di 10mm
  dto=10/p*smxr;
  for (i=0;i<dto;i++)
  {
    m(5,0);
    delay(3);
  }


  for (i=0;i<(2*NP-2);i++)
  {
    xrpr=xepr=yrpr=yepr=dt=0;

    if (abs(steps[i][0])>=abs(steps[i][1]))
    {
      dt=abs(steps[i][0]);
    }
    else
    {
      dt=abs(steps[i][1]);
    }

    if (dt<abs(steps[i][2]))
    {
      dt=abs(steps[i][2]);
    }

    if (dt<abs(steps[i][3]))
    {
      dt=abs(steps[i][3]);
    }

    printf("In taglio il tratto %d\n",i);

    tanxr=(float)steps[i][0]/(float)dt;
    tanyr=(float)steps[i][1]/(float)dt;
    tanxe=(float)steps[i][2]/(float)dt;
    tanye=(float)steps[i][3]/(float)dt;

    for (j=1;j<dt+1;j++)
    {
      xratt=round(tanxr*(float)j);
      yratt=round(tanyr*(float)j);
      xeatt=round(tanxe*(float)j);
      yeatt=round(tanye*(float)j);

      dxr=xratt-xrpr;
      dyr=yratt-yrpr;
      dxe=xeatt-xepr;
      dye=yeatt-yepr;

      p_xr=(p_xr+dxr)%4;
      if (p_xr<0)
        p_xr=3;
      p_yr=(p_yr+dyr)%4;
      if (p_yr<0)
        p_yr=3;
      p_xe=(p_xe+dxe)%4;
      if (p_xe<0)
        p_xe=3;
      p_ye=(p_ye+dye)%4;
      if (p_ye<0)
        p_ye=3;

      p_mot=(seq_xr[p_xr]+seq_yr[p_yr]+seq_xe[p_xe]+seq_ye[p_ye]);

      xrpr=xratt;
      yrpr=yratt;
      xepr=xeatt;
      yepr=yeatt;

      outportb(888,p_mot);

      delay(3);
    }

  }


  printf("\n\n\nTaglio effettuato, rimuovere il pezzo e premere un tasto.");

  getch();

  printf("\n\nPremere un tasto per riazzerare i motori e uscire");
// riposizionamento verticale

  getch();

  if (dtv>0)
  {
    for (i=0;i<dtv;i++)
    {
      m(4,1);
      delay(3);
    }
  }
  else if (dtv<0)
  {
    dtv=-dtv;
    for (i=0;i<dtv;i++)
    {
      m(4,0);
      delay(3);
    }
  }
  for (i=0;i<dto;i++)
  {
    m(5,1);
    delay(3);
  }

}

// ************************** test filo *************************
void test_filo(void)
{
  int scelta;

  clrscr();

  printf("TEST VERIFICA CORREZIONE IRRAGGIAMENTO FILO\n\n\n\n");
  printf("Predisporre due blocchetti di polistirolo di altezza nota\n");
  printf("per effettuare due tagli a velocit massima e dimezzata.\n");
  printf("Misurare la dimensione dei blocchetti tagliati per ricavare\n");
  printf("i fattori di correzione minimo cfmin (blocchetto tagliato a Vmax)\n");
  printf("e massimo cfmax (blocchetto tagliato a velocit minima) in mm\n\n");
  printf("cfmin  la differenza tra la dimensione originale del blocchetto\n\n");
  printf("tagliato a Vmax e la dimensione totale dei pezzi riuniti.\n\n");
  printf("cfmax  la differenza tra la dimensione originale del blocchetto\n\n");
  printf("tagliato a Vmin e la dimensione totale dei pezzi riuniti.\n\n");
  printf("I valori di cfmin e cfmax rilevati andranno immessi nel menu di esportazione\n\n");
  printf("per la porta parallela.\n\n");
  printf("Premere un tasto per procedere al taglio a Vmax o ESC per uscire\n\n");

  scelta = getch();
  if (scelta==27)
  {
    return;
  }

  reg_mx();

}
*/
// **************************** round ***************************
/*
int round(float f)
{
  if (f>0)
  {
    if ((f-(int)f)<=0.5)
    {
      return ((int)f);
    }
    else
    {
      return ((int)f+1);
    }
  }
  else if (f<0)
  {
    if ((f-(int)f)>-0.5)
    {
      return ((int)f);
    }
    else
    {
      return ((int)f-1);
    }
  }
  else
  {
    return 0;
  }
}
*/
